<isol>

#include <GL/glut.h>
#include <stdlib.h>
#include "dave.hh"

Dave*  dave; 
float* simulationtime; 

void renderScene()
{
   glEnable(GL_LIGHTING); 

   /* Simulation: Flying Torus */
   float xt=sin(*simulationtime); 
   float yt=cos(*simulationtime); 
   float zt=0.4*sin(5*(*simulationtime)); 
   glPushMatrix(); 
   glTranslatef(xt,yt,zt); 
   glutSolidTorus(0.1,0.2,20,20); 
   glPopMatrix();

   /* Head: with tori on principal planes */
   glPushMatrix();
   dave->headCSToOpenGL (); 
   glutSolidTorus(0.02,1.00,4,36);
   glPopMatrix(); 

   /* Mouse: Sphere */
   t_3DVector p = dave->getMousePosition() + 0.4*dave->getMouseY(); 
   glPushMatrix(); 
   glTranslatef(p.x,p.y,p.z);
   glutSolidSphere(0.08,10,10);
   glPopMatrix();

   /* Teapot in the center */
   glPushMatrix(); 
   glRotatef(90,1,0,0); 
   glRotatef(90,0,1,0); 
   glutWireTeapot(0.3); 
   glPopMatrix(); 
}

void glWindow_reshape(int w, int h)
{
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
}

void glWindow_init(void) 
{
   glClearColor(0,0,0,1);
   glDisable(GL_CULL_FACE);
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_LIGHT0);
   glEnable(GL_LIGHT1);

   dave->initOpenGL();   // color correction
}

void glWindow_display()
{
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

   dave->setProjectionGL(); 
   renderScene(); 
   dave->synchronize(); 

   if(dave->isStopped()) { exit(0); }

   glutSwapBuffers();
   glutPostRedisplay();    
}

int main(int argc, char* argv[])
{
   dave = new Dave(sizeof(float)); 

   simulationtime = (float*) dave->getSyncBuffer(); 

   if(dave->isClient()) { 
      glutInit(&argc,argv);
      glutInitDisplayMode (GLUT_RGB|GLUT_DOUBLE|GLUT_DEPTH);
      glutInitWindowSize (500, 500); 
      glutCreateWindow ("Test the DAVE");
      glWindow_init ();
      glutDisplayFunc(glWindow_display); 
      glutReshapeFunc(glWindow_reshape); 
      glutMainLoop();
   }

   if(dave->isServer()) { 
      (*simulationtime) = 0; 
      while(!dave->isStopped()) { 
         (*simulationtime)+=0.01; 
         dave->synchronize(); 
      }
   }

   return 0;
}
